clear all

reps = 30;%repetitions of the block
adqTime =1.7; %adquisition time
soundTime = 8.3; %sound reproduction time

PsychPortAudio('Verbosity', [0]);
% User input
participantName = input('Participant name? ', 's');
typeOfRun = input('Type of run? ', 's');
trigger= input('Start type? Press s for scanner, k for keyboard: ','s');
if trigger=='s'
    trigchk = 1;
    %%% -----------------------------
    % Prepare parallel port
    par_interface=1;
    par_port_address=889;
    rpstring{1}='read_parallel(par_port_address,ioObj)';
    rpstring{2}='lptread(par_port_address)';
    % prepare parallel port
    % load x64 IO parallel port
    ioObj = io64;
    % initialize the interface to the inpoutx64 system driver
    status = io64(ioObj);
    
else
    trigchk = 0;
end

% Preparing to read parallel port
if trigchk == 1
    switch par_interface
        case 1
            %read_parallel_init;
            write_parallel(890,bitset(uint8(read_parallel(890,ioObj)),6,1));
        case 2
            lptread_init(par_port_address);
        otherwise
    end
    eval(rpstring{par_interface});
end



%%% -----------------------------

[~, Fs] = audioread('1_Sf_a1.wav',[1,2]);

timeSteps = [adqTime];
for j  = 1:reps
    timeSteps = [timeSteps,soundTime,adqTime];

end
timeLine = [cumsum(timeSteps)];
audioSize = Fs * soundTime;

% Loads the csv file with the file's names
filename = ['run',num2str(typeOfRun),'.csv'];
delimiter = '';
formatSpec = '%s%[^\n\r]';
fileID = fopen(filename,'r');
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter,  'ReturnOnError', false);
fclose(fileID);
fileList = [dataArray{1:end-1}];
% Clear temporary variables
clearvars filename delimiter formatSpec fileID dataArray ans;




InitializePsychSound(0);
%
wfsignal = 1;
pause(1)
disp('Waiting for start')
% Wait for trigger
while wfsignal == 1
    [keyisdown, secs, keycode]=KbCheck;
    if  (keyisdown) || (trigchk && bitand(uint8(eval(rpstring{par_interface})),uint8(64)))
        wfsignal=0;
    end
end

% error('r')
disp('Starting')
%%
tic;
logMat = cell(length(timeLine),4);
for j = 1:length(timeLine)-1
    audioFile = [fileList{j},'.wav'];
    if ~strcmp(audioFile,'Acq.wav')
        [audioData, Fs] = audioread(audioFile);
        %Cuts and pastes again the sound to check that it ends with the
        %scanner sound, should be removed for the actual session
        %cutSite = round(size(audioData,1)/2);
        %audioData = [audioData(1:cutSite,1);audioData(:,1)];
        
        MySongChannels = 2;
        MySongHandle = PsychPortAudio('Open', [], [], 0, Fs, MySongChannels);
        tamAudio = size(audioData,1);
        audioVector = zeros(audioSize,2);
        if tamAudio > audioSize 
            audioVector(1:audioSize,1) = audioData(1:audioSize,1);
            %audioVector(1:audioSize,2) = audioData(1:audioSize,2);
        else
            audioVector(1:tamAudio,1) = audioData(1:tamAudio,1);
            %audioVector(1:tamAudio,2) = audioData(1:tamAudio,2);
        end
        audioVector(:,2) = audioVector(:,1);
        MySongFile = audioVector;
        n =1;
             % The following lines of code are necessary for PsychPortAudio's handling of the wav file. 
        MySongData = MySongFile';
        MySongChannels = size(MySongData,1);          % Number of rows == number of channels.
        Channels = size(MySongData,1);          % Number of rows == number of channels.
             % Performing a basic initialization of the sound driver

             % Open the default audio device [], with default mode [] (==Only playback)
             % A required latency class of zero 0 == no low-latency mode
             % A frequency of freq and nrchannels sound channels.  This returns a handle to the audio device:


             % Fill the audio playback buffer with the audio data
        PsychPortAudio('FillBuffer', MySongHandle, MySongData);

             % Starting audio playback for 'n' repetitions of the sound data,
             % start it immediately (0) and wait for the playback to start, return onset
             % timestamp.
             
        timeLapsed = toc;
        logMat{j,1} = timeLapsed;
        logMat{j,4} = timeLine(j);
        pause(timeLine(j)-timeLapsed);
        disp(['Playing ', audioFile]);
        disp(timeLapsed);
        logMat{j,2} = timeLapsed;
        logMat{j,3} = audioFile;
        StartMusic = PsychPortAudio('Start', MySongHandle, n, 0, 1);
    else
        timeLapsed = toc;
        logMat{j,1} = timeLapsed;
        logMat{j,4} = timeLine(j);
        pause(timeLine(j)-timeLapsed);
        logMat{j,2} = timeLapsed;
        logMat{j,3} = audioFile;
    end
    
    
        
    % To end your audio playback at some later point in the script
    %PsychPortAudio('Stop', MySongHandle);
    %PsychPortAudio('Close', MySongHandle);
    clear Channels
    clear MySongBits
    clear MySongChannels
    clear MySongData
    clear MySongFile
    clear MySongFreq
    clear MySongHandle
    clear n
    clear StartMusic
    
    
end

clearvars -except typeOfRun participantName logMat
dateAndTime = datetime('now');
save([participantName,'_run',typeOfRun,date,'rnd',num2str(round(rand(1)*100))]);
disp('Data saved, reproduction ended')